require 'omniauth-oauth2'

module OmniAuth
  module Strategies
    class Weixin < OmniAuth::Strategies::OAuth2

      DEFAULT_SCOPE = 'snsapi_base,snsapi_userinfo'

      option :name, 'weixin'

      option :client_options, {
        :site          => 'https://api.weixin.qq.com',
        :authorize_url => 'https://open.weixin.qq.com/connect/qrconnect',
        :token_url     => '/sns/oauth2/access_token'
      }

      uid { raw_info['openid'] }

      info do
        {
        }
      end

      extra {}

      def raw_info
        @raw_info ||= nil
      end

      def authorize_params
        super.tap do |params|
          params[:appid] = options.client_id
          params[:scope] ||= request.params['scope'] || DEFAULT_SCOPE
        end
      end

      def token_params
        super.tap do |params|
          params[:parse]  = :json
          params[:appid]  = options.client_id
          params[:secret] = options.client_secret
        end
      end
    end
  end
end

OmniAuth.config.add_camelization 'weixin', 'Weixin'
